# Колпачный фреймворк для ВКонтакте
Развивается как многопоточный фреймворк с поддержкой всех возможностей API ВКонтакте, а так же не добавленных, но необходимых функций, работу с большим количеством роботов под разными сессиями, поддерживающий PSR-спецификацию и полностью покрытый тестами

### Установка:
```sh
$ composer install hood/vk
```
### Пример использования:
```php
use hood\vk\core;
use hood\accounts\vk;

// Подключение библеотек
require_once './vendor/autoload.php';

// Инициализация пользователя ВКонтакте
$account = (new vk($id))->auth('login', 'password')->key($project_id);

// Инициализация робота-группы
$robot = core::init()->group($account);

// Отправка сообщения
$robot->message($to, 'Привет, я создал робота!');
```