<?php

declare(strict_types=1);

namespace hood\vk\robots;

use Exception;

use GuzzleHttp\Client as browser;

<<<<<<< HEAD
use hood\vk\core,
    hood\vk\api\methods\method,
    hood\vk\proxies\proxy,
    hood\vk\captcha\captcha;

use hood\accounts\vk as account;

/**
 * Робот
 *
 * $id Идентификатор
 * $session Сессия
 * $key Ключ
 * $version Версия API
 * $account Аккаунт
 * $browser Браузер
 * $proxy Прокси
 * $captcha Обработчик капчи
 *
 * $messages_mode Режим отправки сообщений
 *
 * public function __construct(int $id = null, float $version = null) Конструктор
 * public function key(string $key) Инициализация ключа
 * public function account(account $account) Инициализация аккаунта
 * public function __set($name, $value) Запись свойства
 * public function __get($name) Чтение свойства
 * public function __isset($name) Проверка на инициализированность свойства
 * public function __call(string $method, array $params) Вызов метода
 * public static function __callStatic(string $method, array $params) Вызов статического метода
 * public function __toString() Конвертация в строку
=======
use hood\vk\core;
use hood\vk\proxies\proxy;
use hood\vk\captcha\captcha;
use hood\vk\api\api;
use hood\vk\api\methods\method;

use hood\accounts\vk as account;


/**
 * Робот
 *
 * @var int $id Идентификатор
 * @var int $session Сессия
 * @var string $key Ключ
 * @var api $api API ВКонтакте
 * @var account $account Аккаунт
 * @var browser $browser Браузер
 * @var proxy $proxy Прокси
 * @var captcha $captcha Обработчик капчи
 *
 * @var int $messages_mode Режим отправки сообщений
 *
 * @method public function __construct(int $id = null, float $version = null) Конструктор
 * @method public function key(string $key) Инициализация ключа
 * @method public function account(account $account) Инициализация аккаунта
 * @method public function __set($name, $value) Запись свойства
 * @method public function __get($name) Чтение свойства
 * @method public function __isset($name) Проверка на инициализированность свойства
 * @method public function __call(string $method, array $params) Вызов метода
 * @method public static function __callStatic(string $method, array $params) Вызов статического метода
 * @method public function __toString() Конвертация в строку
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
 *
 * @package hood\vk\robots
 * @author Arsen Mirzaev Tatyano-Muradovich <red@hood.su>
 */
abstract class robot
{
    /**
<<<<<<< HEAD
     * Идентификатор
     */
    protected int $id;

    /**
     * Сессия
=======
     * @var int Сессия
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
     */
    protected int $session;

    /**
<<<<<<< HEAD
     * Ключ
=======
     * @var string Ключ
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
     */
    protected string $key;

    /**
<<<<<<< HEAD
     * Версия API
     */
    protected float $version = 5.124;

    /**
     * Аккаунт
=======
     * @var string Аккаунт
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
     */
    private account $account;

    /**
<<<<<<< HEAD
     * Прокси
=======
     * @var proxy Прокси
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
     */
    protected proxy $proxy;

    /**
<<<<<<< HEAD
     * Обработчик капчи
=======
     * @var captcha Обработчик капчи
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
     */
    protected captcha $captcha;

    /**
<<<<<<< HEAD
     * $messages_mode Режим отправки сообщений
     */
    protected int $messages_mode = 1;

=======
     * @var int Режим отправки сообщений
     */
    protected int $messages_mode = 1;

    /**
     * @var api API ВКонтакте
     */
    protected api $api;
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4

    /**
     * Конструктор
     *
<<<<<<< HEAD
     * $id Идентификатор
     * $version Версия API
     */
    public function __construct(int|null $id = null, float|null $version = null)
    {
=======
     * @param int $id Идентификатор
     */
    public function __construct(
        protected int|null $id = null,
    ) {
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
        // Инициализация ядра
        $core = core::init();

        // Идентификация робота
        $this->id = empty($id) ? $core->robots + 1 : $id;

        // Регистрация робота в ядре
        $core->set($this->id, $this);

        // Идентификация сессии робота
        $this->session = count($core->get($this->id));
<<<<<<< HEAD

        if (isset($version)) {
            // Инициализация версии
            $this->version = $version;
        }
=======
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
    }

    /**
     * Инициализация ключа
     *
<<<<<<< HEAD
     * $key Ключ
=======
     * @param string $key Ключ
     *
     * @return self
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
     */
    public function key(string $key): self
    {
        if (!isset($this->key)) {
            $this->key = $key;
        } else {
            throw new Exception('Запрещено перезаписывать ключ');
        }

        return $this;
    }

    /**
     * Инициализация аккаунта
     *
<<<<<<< HEAD
     * $account Аккаунт
=======
     * @param account $account Аккаунт
     *
     * @return self
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
     */
    public function account(account $account): self
    {
        if (!isset($this->account)) {
            $this->account = $account;
        } else {
            throw new Exception('Запрещено перезаписывать аккаунт');
        }

        return $this;
    }

    /**
     * Инициализация прокси
     *
<<<<<<< HEAD
     * $proxy Прокси
=======
     * @param proxy $proxy Прокси
     *
     * @return self
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
     */
    public function proxy(proxy $proxy): self
    {
        $this->proxy = $proxy;

        return $this;
    }

    /**
     * Инициализация обработчика капчи
     *
<<<<<<< HEAD
     * $captcha Обработчик капчи
=======
     * @param captcha $captcha Обработчик капчи
     *
     * @return self
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
     */
    public function captcha(captcha $captcha): self
    {
        $this->captcha = $captcha;

        return $this;
    }

    /**
     * Записать свойство
     *
<<<<<<< HEAD
     * $name Название
     * $value Значение
=======
     * @param string $name Название
     * @param mixed $value Значение
     *
     * @return void
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
     */
    public function __set(string $name, mixed $value): void
    {
        match ($name) {
            'id' => !isset($this->id) ? $this->id = (int) $value : throw new Exception('Запрещено перезаписывать идентификатор'),
            'session' => !isset($this->session) ? $this->session = (int) $value : throw new Exception('Запрещено перезаписывать сессию'),
            'key' => !isset($this->key) ? $this->key = (string) $value : throw new Exception('Запрещено перезаписывать ключ'),
<<<<<<< HEAD
            'version' => !isset($this->version) ? $this->version = (float) $value : throw new Exception('Запрещено перезаписывать версию API'),
=======
            'api' => !isset($this->api) ? $this->api = $value : throw new Exception('Запрещено перезаписывать API'),
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
            'account' => !isset($this->account) && $value instanceof account ? $this->account = $value : throw new Exception('Запрещено перезаписывать аккаунт'),
            'browser' => !isset($this->browser) && $value instanceof browser ? $this->browser = $value : throw new Exception('Запрещено перезаписывать браузер'),
            'proxy' => $this->proxy = $value,
            'captcha' => $this->captcha = $value,
            'messages_new' => $this->messages_new = (int) $value,
<<<<<<< HEAD
                // Если свойство не найдено:
=======
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
            default => throw new Exception('Свойство не найдено: ' . $name)
        };
    }

    /**
     * Прочитать свойство
     *
<<<<<<< HEAD
     * $name Название
     *
     * @return mixed
     */
    public function __get(string $name)
    {
        return match ($name) {
            'id' => isset($this->id) ? $this->id : throw new Exception('Идентификатор не инициализирован'),
            'session' => isset($this->session) ? $this->session : throw new Exception('Сессия не инициализирована'),
            'key' => isset($this->key) ? $this->key : throw new Exception('Ключ не инициализирован'),
            'version' => isset($this->version) ? $this->version : throw new Exception('Версия не инициализирована'),
            'account' => isset($this->account) ? $this->account : throw new Exception('Аккаунт не инициализирован'),
=======
     * @param string $name Название
     *
     * @return mixed
     */
    public function __get(string $name): mixed
    {
        return match ($name) {
            'id' => $this->id ?? throw new Exception('Идентификатор не инициализирован'),
            'session' => $this->session ?? throw new Exception('Сессия не инициализирована'),
            'key' => $this->key ?? throw new Exception('Ключ не инициализирован'),
            'api' => $this->api ?? $this->api = new api($this),
            'account' => $this->account ?? throw new Exception('Аккаунт не инициализирован'),
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
            'browser' => $this->browser ?? $this->browser = new browser([
                'base_uri'  => 'https://api.vk.com/method/',
                'cookies'   => true
            ]),
            'proxy' => $this->proxy,
            'captcha' => $this->captcha,
            'messages_new' => $this->messages_new,
<<<<<<< HEAD
                // Если свойство не найдено:
=======
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
            default => throw new Exception('Свойство не найдено: ' . $name)
        };
    }

    /**
     * Проверить свойство на инициализированность
     *
<<<<<<< HEAD
     * $name Название
     *
     * @return mixed
     */
    public function __isset(string $name)
=======
     * @param string $name Название
     *
     * @return mixed
     */
    public function __isset(string $name): bool
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
    {
        return match ($name) {
            'id' => isset($this->id),
            'session' => isset($this->session),
            'key' => isset($this->key),
            'account' => isset($this->account),
<<<<<<< HEAD
            'version' => isset($this->version),
=======
            'api' => isset($this->api),
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
            'browser' => isset($this->browser),
            'proxy' => isset($this->proxy),
            'captcha' => isset($this->captcha),
            'messages_new' => isset($this->messages_new),
            default => throw new Exception('Свойство не найдено: ' . $name)
        };
    }

    /**
     * Вызвать метод
     *
     * Ищет класс описывающий метод API ВКонтакте,
     * создаёт и возвращает его объект
     *
<<<<<<< HEAD
     * $method Метод
     * $params Параметры
=======
     * @param string $method Метод
     * @param array $params Параметры
     *
     * @return method
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
     */
    public function __call(string $method, array $params): method
    {
        if (class_exists($class = '\\hood\\vk\\api\\methods\\' . $method . 's')) {
            // Если найден класс реализующий запрошенный метод
            return new $class($this, ...$params);
        }

        throw new Exception('Метод не найден: ' . $method);
    }

    /**
     * Вызвать статический метод
     *
     * Ищет класс описывающий метод API ВКонтакте,
     * создаёт и возвращает его объект
     *
<<<<<<< HEAD
     * $method Метод
     * $params Параметры
=======
     * @param string $method Метод
     * @param array $params Параметры
     *
     * @return method
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
     */
    public static function __callStatic(string $method, array $params): method
    {
        if (class_exists($class = '\\hood\\vk\\api\\methods\\' . $method . 's')) {
            return $class(self, ...$params);
        }

        throw new Exception('Метод не найден: ' . $method);
    }

    /**
     * Конвертировать в строку
<<<<<<< HEAD
=======
     *
     * @return string
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
     */
    public function __toString(): string
    {
        return (string) $this->id;
    }
}
